var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { Component, ViewContainerRef, ChangeDetectionStrategy, NgModule, Injector, Compiler, Input, Inject } from '@angular/core';
import { CommonModule } from '@angular/common';
import { SANDBOXES } from '../shared/tokens';
export var ScenarioComponent = (function () {
    function ScenarioComponent(sandboxes, compiler, injector, view) {
        this.sandboxes = sandboxes;
        this.compiler = compiler;
        this.injector = injector;
        this.view = view;
    }
    Object.defineProperty(ScenarioComponent.prototype, "selectedSandboxAndScenarioKeys", {
        set: function (selectedSandboxAndScenarioKeys) {
            this.view.clear();
            if (selectedSandboxAndScenarioKeys) {
                var sandbox = this.sandboxes.find(function (sandbox) { return sandbox.key === selectedSandboxAndScenarioKeys.sandboxKey; });
                if (sandbox) {
                    var scenario = sandbox.scenarios.find(function (scenario) { return scenario.key === selectedSandboxAndScenarioKeys.scenarioKey; });
                    if (scenario) {
                        this.loadScenario(sandbox, scenario, this.view, this.injector);
                    }
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    ScenarioComponent.prototype.loadScenario = function (sandbox, scenario, location, injector) {
        var hostComponent = this.hostComponent(scenario);
        var hostModule = this.hostModule(sandbox, hostComponent);
        this.compiler.clearCache();
        var moduleFactory = this.compiler.compileModuleSync(hostModule);
        var moduleRef = moduleFactory.create(injector);
        var componentFactory = moduleRef.componentFactoryResolver.resolveComponentFactory(hostComponent);
        location.createComponent(componentFactory, location.length, moduleRef.injector);
    };
    ScenarioComponent.prototype.hostComponent = function (scenario) {
        var HostComponent = (function () {
            function HostComponent() {
                Object.assign(this, scenario.context);
            }
            HostComponent = __decorate([
                Component({
                    selector: 'host-component',
                    template: scenario.template,
                    styles: scenario.styles,
                    providers: scenario.providers
                }), 
                __metadata('design:paramtypes', [])
            ], HostComponent);
            return HostComponent;
        }());
        return HostComponent;
    };
    ScenarioComponent.prototype.hostModule = function (_a, hostComponent) {
        var imports = _a.imports, type = _a.type, declarations = _a.declarations, providers = _a.providers;
        var HostModule = (function () {
            function HostModule() {
            }
            HostModule = __decorate([
                NgModule({
                    imports: [
                        CommonModule,
                        imports ? imports : []
                    ],
                    declarations: [
                        type,
                        hostComponent,
                        declarations ? declarations : []
                    ],
                    providers: providers ? providers : [],
                    entryComponents: [
                        hostComponent
                    ]
                }), 
                __metadata('design:paramtypes', [])
            ], HostModule);
            return HostModule;
        }());
        return HostModule;
    };
    __decorate([
        Input(), 
        __metadata('design:type', Object), 
        __metadata('design:paramtypes', [Object])
    ], ScenarioComponent.prototype, "selectedSandboxAndScenarioKeys", null);
    ScenarioComponent = __decorate([
        Component({
            selector: 'ap-scenario',
            template: "",
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        __param(0, Inject(SANDBOXES)), 
        __metadata('design:paramtypes', [Object, Compiler, Injector, ViewContainerRef])
    ], ScenarioComponent);
    return ScenarioComponent;
}());
