export var StateService = (function () {
    function StateService() {
        var _this = this;
        this.filter = sessionStorage.getItem('angularPlayground.filter');
        this.selectedSandboxAndScenarioKeys = {
            sandboxKey: sessionStorage.getItem('angularPlayground.sandboxKey'),
            scenarioKey: sessionStorage.getItem('angularPlayground.scenarioKey')
        };
        var beforeUnload = function () {
            _this.saveState();
            return 'unload';
        };
        window.addEventListener('beforeunload', beforeUnload);
    }
    StateService.prototype.getFilter = function () {
        return this.filter;
    };
    StateService.prototype.setFilter = function (value) {
        this.filter = value;
    };
    StateService.prototype.getSelectedSandboxAndScenarioKeys = function () {
        return this.selectedSandboxAndScenarioKeys;
    };
    StateService.prototype.setSandboxAndScenarioKeys = function (value) {
        this.selectedSandboxAndScenarioKeys = value;
    };
    StateService.prototype.saveState = function () {
        sessionStorage.setItem('angularPlayground.filter', emptyStringIfNull(this.filter));
        sessionStorage.setItem('angularPlayground.sandboxKey', emptyStringIfNull(this.selectedSandboxAndScenarioKeys.sandboxKey));
        sessionStorage.setItem('angularPlayground.scenarioKey', emptyStringIfNull(this.selectedSandboxAndScenarioKeys.scenarioKey));
    };
    return StateService;
}());
function emptyStringIfNull(value) {
    return value ? value : '';
}
